#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "scr_tbl.h"
//========== SPECIAL TABULAR-LIKE WIDGET ==========================
//MUST USE malloc/free here
//Also, I need a proc to rebuild an array of links
//Draw procedure can:
//1) check for difference compared to last call
//2) not call it, do it manually
//3) NEVER do it
//-------------------------------------------------------------------
//DAMN, I need to rewrite it --- it must be always in editing mode!
//But, one can easily use it for display only --- just DO not call
//injectchar ;) Simple.
//MAKE a validation wrapper & standard validation & display functions...
//DAMN! Current implementation inherently broken, as displayed values
//are NOT necessary numbers, so they can't be simply get back-in
//by strtol!!!! AND second: dirty hack required after replacing 
//display function! (to redisplay current value)
//WHAT can I do with it?
//1. Include INPUT function to convert values back
//+ all displayed values could be entered back
//- the function itself. (ordinary, don't forget to input all numbers)
//+ but it's more flexible
//- where SHOULD be validation returned from it!
//+ can replace validator with it
//2. Include EDITED/UNEDITED state
//+ can take out "dirty hack" problem
//- harder to implement (but so what?!)
// THIS sucks, because displvalue needs to display INVALID values somehow!?
// BUT CAN BE DONE

 int scr_spectable_compfunc0(const void* first, const void* second);
 int scr_spectable_compfunc1(const void* first, const void* second);

//must return -1 if invalid, or valid value
int scr_spectable_valinput(char* value)
{
//REMAKE this to accept just numbers 0<=x<=255, and '\0' as 0?
size_t len,goodlen;
int tmpval;
len=strlen(value); //must be NUL-terminated
if (!len) return 0; // '\0' is 0?

goodlen=strspn(value,"0123456789 ");
if (len != goodlen) return -1;
tmpval=(int) strtol(value,(char**)NULL,10);
if (tmpval>255) return -1;
return tmpval;
}

void scr_spectable_displvalue(unsigned char value, char* buffer)
{
sprintf(buffer,"%u",value);
}

Scr_spectable* scr_spectable_create(unsigned char x, unsigned char y, 
	unsigned char xlen, unsigned char ylen, unsigned char fieldlen,
	unsigned int numfields, unsigned char (*coords)[2],
        unsigned char* data)
{
Scr_spectable* tmptable;
tmptable=malloc(sizeof(Scr_spectable));
if (!tmptable) return NULL;
tmptable->header.widgtype=SCR_WT_SPECTABLE;
tmptable->header.x=x;
tmptable->header.y=y;
tmptable->header.ylen=ylen;
tmptable->header.xlen=xlen;
tmptable->header.color=scr_curr_attr; //default

tmptable->coords=coords;
tmptable->fieldlen=fieldlen;
tmptable->numfields=numfields;
tmptable->data=data;

tmptable->curspos=0;
tmptable->displvalue=scr_spectable_displvalue;
tmptable->valinput=scr_spectable_valinput;
tmptable->currfieldnum=0;
tmptable->editing=0;
tmptable->exittype=0;

tmptable->currfield=malloc(80*sizeof(char));
if (!tmptable->currfield) {
    free(tmptable);
    return NULL;
    };
//display field[0] value there!
tmptable->displvalue(tmptable->data[0], tmptable->currfield);
//But. I need to redisplay AFTER changing DISPLAY function!

tmptable->links=malloc(sizeof(unsigned int[4])*numfields);
if (!tmptable->links) {
    free(tmptable->currfield);
    free(tmptable);
    return NULL;
    };

//ADDed coords validation on creation:
if (!scr_spectable_validate(tmptable)) {
    scr_spectable_destroy(tmptable);
    return NULL;
    };
    
//ADD building of links on creation!
scr_spectable_makelinks(tmptable);

return tmptable;
}

void scr_spectable_destroy(Scr_spectable* table)
{
free(table->currfield);
free(table->links);
free(table);
}

void scr_spectable_draw(Scr_spectable* table)
{
//here, we just draw all the fields
//we DON'T need to update links here...
//REMAKE
unsigned int f;
unsigned char g,tmpsize,x,y;
char tmpfield[80]="";
scr_attr tmpattr;
tmpattr=table->header.color;
for (f=0;f<table->numfields;f++) {
if (table->currfieldnum==f && table->editing) { //CORRECTED
   strcpy(tmpfield, table->currfield);
   } else {
   table->displvalue(table->data[f], tmpfield);
   };

//value prepared for output
x=table->coords[f][0];
y=table->coords[f][1];
tmpsize=strlen(tmpfield);
for (g=0;g<table->fieldlen;g++) {
    if (g<tmpsize) scr_mvaddch(x+g,y,scr_to_scr_char(tmpfield[g],tmpattr));
    else scr_mvaddch(x+g,y,scr_to_scr_char(' ',tmpattr));
};
}
scr_cursor(table->coords[table->currfieldnum][0]+table->curspos,
	   table->coords[table->currfieldnum][1]);
}

//validate coords | -REWRITE
int scr_spectable_validate(Scr_spectable* table)
{
unsigned int f;
unsigned char minx,miny,maxx,maxy;
minx=table->header.x;
miny=table->header.y;
maxx=minx+table->header.xlen;
maxy=miny+table->header.ylen;
for (f=0;f<table->numfields;f++) {
    if (
        (table->coords[f][0]+table->fieldlen>maxx) ||
        (table->coords[f][0]<minx) ||
        (table->coords[f][1]>maxy) ||
        (table->coords[f][1]<miny)
       ) return 0;
    };
return 1;
}

//create links from coords
//TODO: finish the linking
void scr_spectable_makelinks(Scr_spectable* table)
{
unsigned int f;
unsigned int (*tmpcoords)[3]; //pointer to array of screen coords
unsigned char g,oldx,oldy,curry,currindex,oldindex,mindist,minindex;
//here I apply all sorting, etc.
//I need temporary storage for sorting here:
if (table->numfields<2) return;
tmpcoords=malloc(sizeof(unsigned int[3])*table->numfields);
assert(tmpcoords);

for (f=0;f<table->numfields;f++) {
    for (g=0;g<4;g++) table->links[f][g]=0xFFFF;
    tmpcoords[f][0]=table->coords[f][0];
    tmpcoords[f][1]=table->coords[f][1];
    tmpcoords[f][2]=f;
    };

//First. Link by exact horiz-vert match!

qsort(tmpcoords,
       table->numfields,
       sizeof(unsigned int[3]),
       scr_spectable_compfunc1);

//dump sorted data HERE!!!

oldx=tmpcoords[0][0];
for (f=1;f<table->numfields;f++) {
    if (tmpcoords[f][0]==oldx) {
	table->links[tmpcoords[f][2]][0]=tmpcoords[f-1][2];  //UP
	table->links[tmpcoords[f-1][2]][1]=tmpcoords[f][2];  //DOWN
	};
    oldx=tmpcoords[f][0];
    };

qsort(tmpcoords,
       table->numfields,
       sizeof(unsigned int[3]),
       scr_spectable_compfunc0);

oldy=tmpcoords[0][1];
for (f=1;f<table->numfields;f++) {
//  if (tmpcoords[f][1]==oldy) {
	table->links[tmpcoords[f][2]][2]=tmpcoords[f-1][2];  //UP
	table->links[tmpcoords[f-1][2]][3]=tmpcoords[f][2];  //DOWN
//  };
    oldy=tmpcoords[f][1];
};

//Second. Link the rest of points 

free(tmpcoords);
}

int scr_spectable_compfunc0(const void* first, const void* second)
{
unsigned int (*dfirst)[3];
unsigned int (*dsecond)[3];
unsigned int x1,x2,y1,y2;
dfirst=(unsigned int (*)[3]) first;
dsecond=(unsigned int (*)[3]) second;
x1=(*dfirst)[0];
y1=(*dfirst)[1];
x2=(*dsecond)[0];
y2=(*dsecond)[1];
return (y1*256+x1)-(y2*256+x2);
}

int scr_spectable_compfunc1(const void* first, const void* second)
{
unsigned int (*dfirst)[3];
unsigned int (*dsecond)[3];
unsigned int x1,x2,y1,y2;
dfirst=(unsigned int (*)[3]) first;
dsecond=(unsigned int (*)[3]) second;
x1=(*dfirst)[0];
y1=(*dfirst)[1];
x2=(*dsecond)[0];
y2=(*dsecond)[1];
return (x1*256+y1)-(x2*256+y2);
}

int scr_spectable_inject(Scr_spectable* table, int thechar)
{
//chars are injected here...
unsigned char curspos,currlen;
int ecode;
int tmpvalue;

ecode=SCR_EC_OK;
currlen=strlen(table->currfield); //always contains current value
curspos=table->curspos;

switch (thechar)
     {     
     case ' ':
       //a loop on values.
       //DO validation here... 
       if (table->editing) tmpvalue=table->valinput(table->currfield); else
			   tmpvalue=table->data[table->currfieldnum];
       if (tmpvalue >= 0) {
           //now loop on values till a correct one is found...
	   tmpvalue++;
           table->displvalue(tmpvalue, table->currfield);
           while (table->valinput(table->currfield)<0) {
	       tmpvalue=(unsigned char) (tmpvalue+1); //CHECK
	       table->displvalue(tmpvalue, table->currfield);
	       };
           table->data[table->currfieldnum]=tmpvalue;
	   table->editing=0; //no more...
	   curspos=0; //no more...
           }; //
       break;
     case SCR_KEY_UP:
       //do validation here...
       if (table->links[table->currfieldnum][0]!=0xFFFF) {
	   if (table->editing) {
		   tmpvalue=table->valinput(table->currfield);
		   if (tmpvalue >= 0) {
		   table->data[table->currfieldnum]=tmpvalue; //assign
		   } else break; //Do NOT step otherwise!
	       };
	   table->currfieldnum=table->links[table->currfieldnum][0];
	   table->displvalue(table->data[table->currfieldnum],
		             table->currfield);
	   //MAY BE, drop previous line
	   table->editing=0; //no more...
	   curspos=0; //no more...
	   };
       break;
     case SCR_KEY_DOWN:
       //do validation here...
       if (table->links[table->currfieldnum][1]!=0xFFFF) {
	   if (table->editing) {
		   tmpvalue=table->valinput(table->currfield);
		   if (tmpvalue >= 0) {
		   table->data[table->currfieldnum]=tmpvalue; //assign
		   } else break; //Do NOT step otherwise!
	       };
	   table->currfieldnum=table->links[table->currfieldnum][1];
	   table->displvalue(table->data[table->currfieldnum],
		             table->currfield);
	   //MAY BE, drop previous line
	   table->editing=0; //no more...
	   curspos=0; //no more...
	   };
       break;
     case SCR_KEY_LEFT:
       //depends on position... 
       if (table->editing) { //IN edit mode
       if (curspos>0) {
           curspos--;
	   break; //nothing more should be done...
           };
       //validate a value JUST in edit mode:
       tmpvalue=table->valinput(table->currfield);
       if (tmpvalue >= 0) {
	   table->data[table->currfieldnum]=tmpvalue; //assign
	   } else break;//Do NOT step otherwise!
       };
       //so, if we are here, try to move somethere...
       if (table->links[table->currfieldnum][2]!=0xFFFF) {
           table->currfieldnum=table->links[table->currfieldnum][2];
	   table->displvalue(table->data[table->currfieldnum],
	                     table->currfield);
	   table->editing=0;
	   curspos=0; //no more...
	   };
       break;
     case SCR_KEY_RIGHT:
       //depends on position... 
       if (table->editing) { //IN edit mode
       if (curspos<currlen) {
	   curspos++;
	   break; //nothing more should be done...
	   };
       //validate a value JUST in edit mode:
       tmpvalue=table->valinput(table->currfield);
       if (tmpvalue >= 0) {
	   table->data[table->currfieldnum]=tmpvalue; //assign
	   } else break;//Do NOT step otherwise!
       };
       //so, if we are here, try to move somethere...
       if (table->links[table->currfieldnum][3]!=0xFFFF) {
           table->currfieldnum=table->links[table->currfieldnum][3];
	   table->displvalue(table->data[table->currfieldnum],
	                     table->currfield);
	   table->editing=0;
	   curspos=0; //no more...
	   };
       break;
     case SCR_KEY_TAB:
       //depends on position... 
       if (!table->editing) { //NOT in edit mode
           table->currfieldnum=(table->currfieldnum+1)%table->numfields;
	   table->displvalue(table->data[table->currfieldnum],
	                     table->currfield);
	   table->editing=0;
	   curspos=0; //no more...
     	   };
       break;
     case SCR_KEY_ENTER:  //try to accept 
	  if (table->editing) { //IN edit mode
	  //validate a value JUST in edit mode:
	  tmpvalue=table->valinput(table->currfield);
	  if (tmpvalue >= 0) {
	      table->data[table->currfieldnum]=tmpvalue; //assign
	      } else break;//Do NOT step otherwise!
	  };
	  ecode=SCR_EC_ENTER;
          break;
     case SCR_KEY_ESC:  //exit a table, no validation here?
          ecode=SCR_EC_ESC;
          break;
     case SCR_KEY_BACKSPACE:
          //I can skip editing check?
          if (curspos>0) {
              curspos--; 
              (void) memmove(table->currfield+curspos,
                             table->currfield+curspos+1,
                             currlen-curspos);
              table->editing=1;
          };
          break;
     case SCR_KEY_DELETE:
          if (!table->editing) {
	      tmpvalue=table->data[table->currfieldnum];
	      table->displvalue(tmpvalue, table->currfield);
	      currlen=strlen(table->currfield);
	      };

          (void) memmove(table->currfield+curspos,
                         table->currfield+curspos+1,
                         currlen-curspos); //Is it good, at all?
          table->editing=1;
          break; 
     default: //unrecognized 
          if (thechar<256)  { //ignore if too big (simple check)
              if (currlen<table->fieldlen) {
              //insert char into current pos.
                 (void) memmove(table->currfield+curspos+1,
                                table->currfield+curspos,
                                currlen-curspos+1); 
              table->currfield[curspos]=thechar;
              curspos++; 
              table->editing=1;
              }
          ecode=SCR_EC_OK;
          };
          break;
     };

table->curspos=curspos;
table->exittype=ecode;

scr_spectable_draw(table);
table->exittype=ecode;
return ecode;
}

	/*
        if (table->links[f][0]==0xFF) {
	    //   
	    //find closest X to current
	    mindist=0xFF; //+oo
	    minindex=0xFF; //+oo
	    //little optimization can be done here... but who cares?
	    for (g=oldindex;g<currindex;g++) {
		if (table->links[g][1]==0xFF) {
		    if (mindist>abs(tmpcoords[f][0]-tmpcoords[g][0])) {
			mindist=abs(tmpcoords[f][0]-tmpcoords[g][0]);
			minindex=g;
		        };
		    };
		};
	    //what if not found?
	    table->links[f][0]=minindex;  //UP
	    table->links[minindex][1]=f;  //DOWN
	    }; */
