#include <time.h>
#include "scr_ml.h"

void test_hscrollbar(void) 
{
Scr_hscrollbar* hbar1;
Scr_vscrollbar* vbar1;
int mychar;

hbar1=scr_hscrollbar_create(3,3,2+8);
vbar1=scr_vscrollbar_create(7,7,5+3);
scr_drawbox(2,2,4+8,3);
scr_drawbox(6,6,3,7+3);
scr_hscrollbar_draw(hbar1);
scr_vscrollbar_draw(vbar1);
scr_refresh(); 

while (1) {
mychar=scr_getch();
scr_mvprintf(20,19,"got char: %X ",mychar);
if (mychar == SCR_KEY_ENTER) break;
if (mychar == SCR_KEY_LEFT) 
    {
    if (hbar1->currpos>0) hbar1->currpos--;
    if (vbar1->currpos>0) vbar1->currpos--;
    };
if (mychar == SCR_KEY_RIGHT) 
    {
    if ((1+hbar1->currpos)<hbar1->header.xlen) hbar1->currpos++;
    if ((1+vbar1->currpos)<vbar1->header.ylen) vbar1->currpos++;
    }
scr_mvprintf(10,17,"hbar currpos:  %u    ",hbar1->currpos);
scr_mvprintf(10,18,"vbar currpos:  %u    ",vbar1->currpos);
scr_hscrollbar_draw(hbar1);
scr_vscrollbar_draw(vbar1);
scr_refresh(); 
}

scr_widget_destroy(hbar1);
scr_widget_destroy(vbar1);
}

int main(void)
{
scr_initscr();
scr_hidecursor();
scr_mvprintf(10,10,"Width,height = %u,%u",scr_width,scr_height);
test_hscrollbar();

scr_stopscr();
return 0;
}
