#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include "scr_ml.h"
#include "scr_tbl.h"

#define MAG_X 200
#define MAG_Y 300

void test_table(void) 
{
Scr_spectable* spectable1;
int f,g,x1,y1,x2,y2,myrnd;
int mychar,ecode;
//int mychar;
FILE* figfile;
unsigned char currlink;
unsigned char (*coords)[2]; //pointer to array of screen coords
unsigned char *data;

srand (time(0));

//myrnd=1+(int) (40.0*rand()/(RAND_MAX+1.0));
myrnd=24*2;
data=malloc(sizeof(unsigned char)*myrnd);
coords=malloc(sizeof(unsigned char[2])*myrnd);
//malloced all RAM

x1=1; y1=1; g=0;
for (f=0;f<myrnd;f++) {
data[f]=f;
//coords[f][0]=0+(int) (75.0*rand()/(RAND_MAX+1.0));
//coords[f][1]=0+(int) (22.0*rand()/(RAND_MAX+1.0));
coords[f][0]=x1;
coords[f][1]=y1;
g++;
if (g==22) {
    g=0;
    y1+=2;
    };
x1+=4;
if (x1>=24) {x1=1; y1+=2;};
}

spectable1=scr_spectable_create(1, 1, 70, 22, 3, myrnd, coords, data);
scr_spectable_draw(spectable1);
scr_refresh(); 

#if 0
scr_stopscr();
//now print out the table of links!:
for (f=0;f<spectable1->numfields;f++) {
printf("NUM: %d (%u,%u) . U: %u, D: %u, L: %u, R: %u\n",f,
	spectable1->coords[f][0],
	spectable1->coords[f][1],
	spectable1->links[f][0],
	spectable1->links[f][1],
	spectable1->links[f][2],
	spectable1->links[f][3]);
}

figfile=fopen("out.fig","wb");

for (f=0;f<spectable1->numfields;f++) {
x1=spectable1->coords[f][0]*MAG_X;
y1=spectable1->coords[f][1]*MAG_Y;
//it's a circle
fprintf(figfile,"1 3 0 1 0 14 50 0 20 0.000 1 0.0000 %d %d 45 45 4050 2250 4050 2205\n",x1,y1);
//now draw all links:
for (g=0;g<4;g++) {
currlink=spectable1->links[f][g];
if (currlink!=0xFF) 
   {
   x2=spectable1->coords[currlink][0]*MAG_X;
   y2=spectable1->coords[currlink][1]*MAG_Y;
   //it's a line:
   fprintf(figfile,"3 0 0 1 0 7 50 0 -1 0.000 0 1 0 2\n");
   fprintf(figfile,"	  1 1 1.00 60.00 120.00\n");
   fprintf(figfile,"	  %d %d %d %d\n",x1,y1,x2,y2);
   fprintf(figfile,"	  0.000 0.000\n");
   /*
   fprintf(figfile,"2 1 0 1 0 7 50 0 -1 0.000 0 0 -1 0 0 2\n");
   fprintf(figfile,"	  %d %d %d %d\n",x1,y1,x2,y2);
   */
   }
}
};

fclose(figfile);
#endif

ecode=SCR_EC_UNK;
while (ecode != SCR_EC_ENTER) {
mychar=scr_getch();
scr_mvprintf(40,19,"got char: %X    ",mychar);
scr_mvprintf(40,20,"ecode: %d    ",ecode);
ecode=scr_spectable_inject(spectable1,mychar);
scr_refresh(); 
}


return;


}

int main(void)
{
scr_initscr();
//scr_hidecursor();
scr_showcursor();
test_table();

scr_stopscr();
return 0;
}
