#include <time.h>
#include "scr_ml.h"

void test_viewer(void) 
{
Scr_viewer* view1;
int mychar;

char* lines[] = {
		"1.    ",
		"2.  ",
		"3.   ", 
		"4. ",
		"5. ",
		"6.  ",
		"7. ",
		"8. ",
		"9. Scroll",
	        "10. Last",
	        "11.    ",
		"12.  ",
		"13.   ", 
		"14. ",
		"15. ",
		"16.  ",
		"17. ",
		"18. ",
		"19. Scroll",
	        "20. Last",
	        "21.    ",
		"22.  ",
		"23.   ", 
		"24. ",
		"25. ",
		"26.  ",
		"27. ",
		"28. ",
		"29. Scroll"
		};

view1=scr_viewer_create(1,1,78,23,lines,sizeof(lines)/sizeof(lines[0]));

scr_drawbox(view1->header.x-1,view1->header.y-1,
	    view1->header.xlen+2,view1->header.ylen+2);
scr_viewer_draw(view1);
scr_refresh(); 

while (1) {
mychar=scr_getch();
	//scr_mvprintf(20,19,"got char: %X ",mychar);
if (mychar == SCR_KEY_ENTER) break;
scr_viewer_inject(view1,mychar);
scr_refresh(); 
}

scr_widget_destroy(view1);
}

int main(void)
{
scr_initscr();
scr_hidecursor();
test_viewer();

scr_stopscr();
return 0;
}
