#include <time.h>
#include "scr_ml.h"


typedef struct {
int key;
char* keydesr;
} Keyspec;

Keyspec AllKeys[]={
{SCR_KEY_BACKSPACE,"SCR_KEY_BACKSPACE"},
{SCR_KEY_DELETE,"SCR_KEY_DELETE"},
{SCR_KEY_INSERT,"SCR_KEY_INSERT"},
{SCR_KEY_DOWN,"SCR_KEY_DOWN"},
{SCR_KEY_END,"SCR_KEY_END"},
{SCR_KEY_ENTER,"SCR_KEY_ENTER"},
{SCR_KEY_CENTER,"SCR_KEY_CENTER"},
{SCR_KEY_ESC,"SCR_KEY_ESC"},
{SCR_KEY_F1,"SCR_KEY_F1"},
{SCR_KEY_F2,"SCR_KEY_F2"},
{SCR_KEY_F3,"SCR_KEY_F3"},
{SCR_KEY_F4,"SCR_KEY_F4"},
{SCR_KEY_F5,"SCR_KEY_F5"},
{SCR_KEY_F6,"SCR_KEY_F6"},
{SCR_KEY_F7,"SCR_KEY_F7"},
{SCR_KEY_F8,"SCR_KEY_F8"},
{SCR_KEY_F9,"SCR_KEY_F9"},
{SCR_KEY_F10,"SCR_KEY_F10"},
{SCR_KEY_F11,"SCR_KEY_F11"},
{SCR_KEY_F12,"SCR_KEY_F12"},
{SCR_KEY_F13,"SCR_KEY_F13"},
{SCR_KEY_F14,"SCR_KEY_F14"},
{SCR_KEY_F15,"SCR_KEY_F15"},
{SCR_KEY_F16,"SCR_KEY_F16"},
{SCR_KEY_F17,"SCR_KEY_F17"},
{SCR_KEY_F18,"SCR_KEY_F18"},
{SCR_KEY_F19,"SCR_KEY_F19"},
{SCR_KEY_F20,"SCR_KEY_F20"},
{SCR_KEY_HOME,"SCR_KEY_HOME"},
{SCR_KEY_LEFT,"SCR_KEY_LEFT"},
{SCR_KEY_PAGEUP,"SCR_KEY_PAGEUP"},
{SCR_KEY_PAGEDOWN,"SCR_KEY_PAGEDOWN"},
{SCR_KEY_PRINT,"SCR_KEY_PRINT"},
{SCR_KEY_PAUSE,"SCR_KEY_PAUSE"},
{SCR_KEY_RIGHT,"SCR_KEY_RIGHT"},
{SCR_KEY_TAB,"SCR_KEY_TAB"},
{SCR_KEY_UP,"SCR_KEY_UP"},
{SCR_KEY_NONE,"SCR_KEY_NONE"}
};

void test_keys(void) 
{
int mychar;
unsigned int f;
unsigned long int g=0;
while (1) {
    mychar=scr_getch_nowait();
    g++;
    if (mychar==SCR_KEY_NONE) continue;
    scr_mvprintf(20,19,"got char: %d   ",mychar);
    scr_mvprintf(20,20,"got key: UNK                     ");
    scr_mvprintf(20,21,"call number: %lu     ",g);
    for (f=0;f<sizeof(AllKeys)/sizeof(AllKeys[0]);f++) {
	if (AllKeys[f].key==mychar) { 
	scr_mvprintf(20,20,"got key: %s      ",AllKeys[f].keydesr);
	break;
	}
    }
    scr_refresh(); 
};
}

int main(void)
{
scr_initscr();
test_keys();
scr_stopscr();
return 0;
}
