#include <time.h>
#include "scr_ml.h"

char* mychoices[] = {
		    "choice 1",
		    "choice two",
		    "3 choice 3",
		    "EXIT",
		    "FIVE! YES!",
		    };

char* mychoices2[] = {
                        "  1",
                        "Choice 2",
                        "Choice 3",
                        "Choice 4",
                        "Exit",
		    };

char* tolabel[] = {
                        "   ",
                        " ",
		    };

void test_menu(void) 
{
Scr_menu* menu1;
Scr_menu* menu2;
Scr_label* label1;
Scr_mlabel* mlabel1;
int mychar,ecode;
unsigned char active=0;

mlabel1=scr_mlabel_create(40,1,10,2,tolabel);
label1=scr_label_create(1,1,1,"some text here to show constant");
menu1=scr_menu_create(5,5, mychoices,sizeof(mychoices)/sizeof(mychoices[0]));
menu2=scr_menu_create(45,5,mychoices2,sizeof(mychoices2)/sizeof(mychoices2[0]));
scr_menu_draw(menu1);
scr_menu_draw(menu2);
scr_label_draw(label1);
scr_mlabel_draw(mlabel1);
scr_refresh(); 
ecode=0;

while (ecode != SCR_EC_ENTER) {
mychar=scr_getch();
scr_mvprintf(20,19,"got char: %X ",mychar);
if (mychar==SCR_KEY_TAB) active=!active;

if (active) {
ecode=scr_menu_inject(menu1,mychar);
} else ecode=scr_menu_inject(menu2,mychar);

label1->header.xlen++;
scr_label_draw(label1);
scr_mvprintf(20,20,"ecode: %u    ",ecode);
scr_refresh(); 
}

scr_widget_destroy(menu1);
scr_widget_destroy(menu2);
scr_widget_destroy(mlabel1);
scr_widget_destroy(label1);
}

int main(void)
{
scr_initscr();
scr_mvprintf(10,10,"Width,height = %u,%u",scr_width,scr_height);
test_menu();

scr_stopscr();
return 0;
}
