#include <time.h>
#include "scr_ml.h"

void test_hprogrbar(void) 
{
Scr_hprogrbar* hbar1;
Scr_vprogrbar* vbar1;
int mychar;

hbar1=scr_hprogrbar_create(3,3,2);
vbar1=scr_vprogrbar_create(7,7,5);
scr_drawbox(2,2,4,3);
scr_drawbox(6,6,3,7);
scr_hprogrbar_draw(hbar1);
scr_vprogrbar_draw(vbar1);
scr_refresh(); 

while (1) {
mychar=scr_getch();
scr_mvprintf(20,19,"got char: %X ",mychar);
if (mychar == SCR_KEY_ENTER) break;
if (mychar == SCR_KEY_LEFT) 
    {
    if (hbar1->currpos>0) hbar1->currpos--;
    if (vbar1->currpos>0) vbar1->currpos--;
    };
if (mychar == SCR_KEY_RIGHT) 
    {
    if (hbar1->currpos<hbar1->header.xlen*2) hbar1->currpos++;
    if (vbar1->currpos<vbar1->header.ylen*2) vbar1->currpos++;
    }
scr_mvprintf(10,17,"hbar currpos:  %u    ",hbar1->currpos);
scr_mvprintf(10,18,"vbar currpos:  %u    ",vbar1->currpos);
scr_hprogrbar_draw(hbar1);
scr_vprogrbar_draw(vbar1);
scr_refresh(); 
}

scr_widget_destroy(hbar1);
scr_widget_destroy(vbar1);
}

int main(void)
{
scr_initscr();
scr_hidecursor();
scr_mvprintf(10,10,"Width,height = %u,%u",scr_width,scr_height);
test_hprogrbar();

scr_stopscr();
return 0;
}
