void scr_refresh(void) {
scr_refresh_ind_linewise();
move(scr_curs_y, scr_curs_x);
refresh();
}

//inits just the character device, not any memory
void scr_initscr_low(void)
{
(void) initscr();
(void) clear();
(void) noecho();
(void) cbreak(); /* Line buffering disabled. Pass on everything */
(void) meta(stdscr, TRUE);
(void) keypad(stdscr,TRUE);
//timeout(50);
//wtimeout(stdscr, 50);
leaveok(stdscr,0);
(void) clear();
move(0,0);
(void) refresh();
}

void scr_stopscr_low(void) //deinits just the character device
{
(void) clrtoeol();
(void) refresh();
(void) endwin();
}

void scr_cursor(unsigned char x,unsigned char y)
{
scr_curs_y=y;
scr_curs_x=x;
}

void scr_hidecursor(void) 
{
(void) curs_set(0);
}

void scr_showcursor(void)
{
(void) curs_set(1);
}

int scr_getch(void) 
{
int toget;
toget=ERR;
while (toget==ERR) toget=getch();
if (toget==10) return SCR_KEY_ENTER;
if (toget==27) return SCR_KEY_ESC;
if (toget==9) return SCR_KEY_TAB;
return toget;
}//think about it, damn it

int scr_getch_nowait(void) 
{
int toget;
(void) nodelay(stdscr, TRUE);
toget=getch();
(void) nodelay(stdscr, FALSE);
if (toget==10) return SCR_KEY_ENTER;
if (toget==27) return SCR_KEY_ESC;
if (toget==9) return SCR_KEY_TAB;
return toget;
}

unsigned char scr_maxx(void) {
return 80;
} //screen width

unsigned char scr_maxy(void) //screen heigth
{
return 25;
}

//type conversion functions:
unsigned char scr_char2char(scr_char ch)
{
return ((unsigned char) (ch & 0xff));
}

scr_attr scr_char2attr(scr_char ch)
{
return (ch & 0xff00);
}

scr_char scr_to_scr_char(unsigned char ch, scr_attr attr)
{
return (attr | ch);
}

scr_attr scr_color2attr(unsigned int color)
{
return 0;
}

unsigned char scr_charcomp(scr_char ch1, scr_char ch2)
{
return (ch1==ch2);
}

//for linewise method:
void scr_drv_showline(unsigned char x, unsigned char y, 
	          unsigned char xlen, scr_char* line)
{
unsigned char f;
for (f=0;f<xlen;f++) {
    attrset(line[f] & 0xff00);
    mvaddch(y,x+f,line[f]);
    }
refresh();
}

//for 'teletype' method:
void scr_drv_home(void)  //position to 0:0
{
move(0,0);
}

void scr_drv_skiplines(unsigned char lines) //skip so much lines
{
}

void scr_drv_skipchars(unsigned char chars) //skip so much chars
{
}

void scr_drv_showstring(unsigned char len, scr_char* line)
{
}

